function convertToCamelCase(str) {
    return str.replace(/(?:^|\s)\w/g, function(match) {
        return match.toUpperCase();
    });
}

( function( $ ) {

var liveEditorGlobal = {};
liveEditorGlobal.lastEditedEl = '';
liveEditorGlobal.multiFontArray = [];

$('.linkfieldBtn').click(function(ev){
  var clickedEl = $(this);
  if (clickedEl.is('span')) {
    if (clickedEl.hasClass('linkedBtn') ) {
      clickedEl.removeClass('linkedBtn');
    }else{
      clickedEl.addClass('linkedBtn');
    }
  }else{
    clickedEl = $(this).parent('span');
    if (clickedEl.hasClass('linkedBtn') ) {
      clickedEl.removeClass('linkedBtn');
    }else{
      clickedEl.addClass('linkedBtn');
    }
  }
});



/* ----------- Live Text Editor Starts Here -------------- */

  function getSelectionParentElement() {
      var parentEl = null, sel;
      if (window.getSelection) {
          sel = window.getSelection();
          if (sel.rangeCount) {
              parentEl = sel.getRangeAt(0).commonAncestorContainer;
              if (parentEl.nodeType != 1) {
                  parentEl = parentEl.parentNode;
              }
          }
      } else if ( (sel = document.selection) && sel.type != "Control") {
          parentEl = sel.createRange().parentElement();
      }
      return parentEl;
  }

  function applyStylesOnSelectedEl(action, value , el){

    if (action == 'bold') {
      if (value == true) {
        $(el).css('font-weight', 'bold');
      }else{
        $(el).css('font-weight', '');
      }
    }
    if (action == 'italic') {
      if (value == true) {
        $(el).css('font-style', 'italic');
      }else{
        $(el).css('font-style', '');
      }
    }
    if (action == 'underlined') {
      if (value == true) {
        $(el).css('text-decoration', 'underline');
      }else{
        tagName = $(el).prop('tagName');
        if (tagName == 'a' || tagName == 'A') {
          $(el).css('text-decoration', 'none');
        }else{
          $(el).css('text-decoration', '');
        }
      }
    }
    if (action == 'strike') {
      if (value == true) {
        $(el).css('text-decoration', 'line-through');
      }else{
        tagName = $(el).prop('tagName');
        if (tagName == 'a' || tagName == 'A') {
          $(el).css('text-decoration', 'none');
        }else{
          $(el).css('text-decoration', '');
        }
      }
    }
    parentElAlignment = $(el).parent().css('text-align');
    ispbTextWidget = false;
    if ( $(el).parent().hasClass('pb-text-widget') ) {
      ispbTextWidget = true;
    }
    pageBuilderApp.pbTextAlignment = false;

    if (action == 'alignLeft') {
      if (value == true) {
        $(el).css('text-align', 'left');
        if (ispbTextWidget == true) {
          pageBuilderApp.pbTextAlignment = 'left';
          $(el).parent().css('text-align', 'left');
        }
      }else{
        $(el).css('text-align', '');
      }
    }
    if (action == 'alignCenter') {
      if (value == true) {
        $(el).css('text-align', 'center');
        if (ispbTextWidget == true) {
          pageBuilderApp.pbTextAlignment = 'center';
          $(el).parent().css('text-align', 'center');
        }
      }else{
        $(el).css('text-align', '');
      }
    }
    if (action == 'alignRight') {
      if (value == true) {
        $(el).css('text-align', 'right');
        if (ispbTextWidget == true) {
          pageBuilderApp.pbTextAlignment = 'right';
          $(el).parent().css('text-align', 'right');
        }
      }else{
        $(el).css('text-align', '');
      }
    }

    if (action == 'fontTag') {
      oldStyles = $(el).attr('style');
      if (typeof(oldStyles) == 'undefined') {
        oldStyles = '';
      }
      tagCustomAttr = '';
      var editedElInnerHtml = el.innerHTML;
      if (typeof(editedElInnerHtml) == 'undefined') {
        editedElInnerHtml = $(el).text();
        oldStyles = $(el).html();
        oldStyles = $(oldStyles).attr('style');
        if (typeof(oldStyles) == 'undefined') {
          oldStyles = '';
        }
      }

      if (oldStyles == '' ) {
        if ( $(el).parents('.pb-text-widget').length ) {
           
          oldStyles = 'font-size:inherit; color:inherit; line-height:inherit; font-family:inherit;';
        }
          
      }

      if (value == 'a') { tagCustomAttr = 'href="#" '; }
      oldStyles = oldStyles.replace(/"/g,"");
      $(el).replaceWith( $('<'+value+'  '+tagCustomAttr+'  style="'+oldStyles+'" class="elLtWrapped" >' + editedElInnerHtml + '</'+value+'>') );
      $('.wltControls').html('');
      $('.liveEditorActive').siblings('.inlineEditingSaveTrigger ').trigger('click');
      $('.wltControls').removeClass('liveEditorActive');
    }
    if (action == 'fontSize') {
      if (value == '' || value == '0') {value = ''; }else{ value = value+'px'; }
      $(el).css('font-size', value);
    }
    if (action == 'fontLineHeight') {
      if (value == '' || value == '0') {value = ''; }else{ value = value+'px'; }
      $(el).css('line-height', value);
    }
    if (action == 'fontLSpace') {
      if (value == '' || value == '0') {value = ''; }else{ value = value+'px'; }
      $(el).css('letter-spacing', value);
    }
    if (action == 'fontColor') {
      $(el).css('color', value);
    }
    if (action == 'linkUrl') {
      tagName = $(el).prop('tagName');
      if (value == '') {  value='#'; }
      if (tagName == 'A' || tagName == 'a') {  $(el).attr('href',value);}
    }
    if (action == 'fontFamily') {
      if (value != '' && value != 'Select' && value != 'Arial' && value != 'Arial Black' && value != 'sans-serif' && value != 'Helvetica' && value != 'Serif' && value != 'Tahoma' && value != 'Verdana' && value != 'Monaco') {
        valuefClass = value.replace(/\+/g, '');
        fontScript = "<link rel='stylesheet' href='https://fonts.googleapis.com/css?family="+value+"' class=loadedfont-"+valuefClass+">";
        if ($('.loadedfont-'+valuefClass).length > 0 && value != 'Select') {}else{
          $(el).parents('.liveTextWrap').find('.ltwFontScript').append(fontScript);
        }
      }
      value = value.replace(/\+/g, ' ');
      if (value == 'Select') { value = ''; }
      $(el).css('font-family', value);
    }

  }

  function editSelectedTextHTML(action, value,modeOfChange) {

    var parentOfSelected = getSelectionParentElement();
    var htmlContents = $(parentOfSelected).html();
    
    try{
      var range = getSelection().getRangeAt(0);
      var contents = range.cloneContents();
      var selectionfound = true;
    } catch(err){
      var contents = '';
      var selectionfound = false;
    }

    var testSpanEl = document.createElement("span");
    testSpanEl.appendChild( contents );
    contents = $(testSpanEl).html();

    if ($(parentOfSelected).parents('.eltEditable').length > 0) {
    }else{
      return;
    }

    if ( $(parentOfSelected).hasClass('elLtWrapped') ) {
      
      if (htmlContents != contents) {
        if (contents == '') {
          applyStylesOnSelectedEl(action, value , parentOfSelected);
        }else{
          var childSpanEl = document.createElement("span");
          var range = getSelection().getRangeAt(0);
          childSpanEl.className = 'elLtWrapped';
          childSpanEl.appendChild(range.extractContents());
          range.insertNode(childSpanEl);
          applyStylesOnSelectedEl(action, value , childSpanEl);
          document.getSelection().removeAllRanges();
          $('.wltBold').prop('checked', false);
        }
      }else{
        applyStylesOnSelectedEl(action, value , parentOfSelected);
      }
    }else{
      if (contents == '') {
        $(parentOfSelected).addClass('elLtWrapped');
        applyStylesOnSelectedEl(action, value , parentOfSelected);
      }else{
        var childSpanEl = document.createElement("span");
        var range = getSelection().getRangeAt(0);
        childSpanEl.className = 'elLtWrapped';
        childSpanEl.appendChild(range.extractContents());
        range.insertNode(childSpanEl);
        applyStylesOnSelectedEl(action, value , childSpanEl);
        document.getSelection().removeAllRanges();
        
        if ( $('.wltBold').is(':checked') ) {
          $('.wltBold').click();
          $('.wltBold').prop('checked', false);
        }
      }
        
    }

  }

  function getSelectedTextHTML() {

    var parentOfSelected = getSelectionParentElement();
    var htmlContents = $(parentOfSelected).html();
    
    try{
      var range = getSelection().getRangeAt(0);
      var contents = range.cloneContents();
      var selectionfound = true;
    } catch(err){
      var contents = '';
      var selectionfound = false;
    }

    var testSpanEl = document.createElement("span");
    testSpanEl.appendChild( contents );
    contents = $(testSpanEl).html();

    if ($(parentOfSelected).parents('.eltEditable').length > 0) {
    }else{
      return;
    }

    if ( $(parentOfSelected).hasClass('elLtWrapped') ) {
      
      if (htmlContents != contents) {
        if (contents == '') {
          
        }else{
          var childSpanEl = document.createElement("span");
          var range = getSelection().getRangeAt(0);
          childSpanEl.className = 'elLtWrapped';
          childSpanEl.appendChild(range.extractContents());
          range.insertNode(childSpanEl);
          var parentOfSelected = childSpanEl;
        }
      }else{
        
      }
    }else{
      if (contents == '') {
        tagName = $(parentOfSelected).prop('tagName');
        tagName = tagName.toLowerCase();

        if (tagName == 'em' || tagName == 'B' || tagName == 'strong') {
          parentOfSelected = $(parentOfSelected).parent();
        }

        secondParentOfEl = $(parentOfSelected).parent();
        secondParenttagName = $(secondParentOfEl).prop('tagName');
        secondParenttagName = secondParenttagName.toLowerCase();

        if (secondParenttagName == 'h1' || secondParenttagName == 'h2' || secondParenttagName == 'h3' || secondParenttagName == 'h4' || secondParenttagName == 'h5' || secondParenttagName == 'h6' || secondParenttagName == 'p' || secondParenttagName == 'a') {
          parentOfSelected = secondParentOfEl;
        }

        $(parentOfSelected).addClass('elLtWrapped');
        
      }else{
        var childSpanEl = document.createElement("span");
        var range = getSelection().getRangeAt(0);
        childSpanEl.className = 'elLtWrapped';
        childSpanEl.appendChild(range.extractContents());
        range.insertNode(childSpanEl);
        var parentOfSelected = childSpanEl;
      }
        
    }


    return parentOfSelected;

  }

  function getStylesSelectedEl(){
    var parentOfSelected = getSelectionParentElement();
    var fontweight = '', fontstyle = '',textdecoration = '', tagName = '';

    if ( $(parentOfSelected).hasClass('elLtWrapped') ) {
      var fontweight = $(parentOfSelected).css('font-weight');
      var fontstyle = $(parentOfSelected).css('font-style');
      var textdecoration = $(parentOfSelected).css('text-decoration');
    }

    var alignmentVal = $(parentOfSelected).css('text-align');
    var tagName = $(parentOfSelected).prop("tagName");
    var fontSize = $(parentOfSelected).css("font-size");
    var lineHeight = $(parentOfSelected).css("line-height");
    var letterSpacing = $(parentOfSelected).css("letter-spacing");
    var fontColor = $(parentOfSelected).css("color");
    var fontFamily = $(parentOfSelected).css("font-family");
    var linkUrl = $(parentOfSelected).attr('href');

    var returnValue  = {
      fontweight : fontweight,
      fontstyle : fontstyle,
      textdecoration : textdecoration,
      tagName : tagName,
      fontSize:fontSize,
      lineHeight: lineHeight,
      letterSpacing: letterSpacing,
      fontColor: fontColor,
      fontFamily: fontFamily,
      alignment: alignmentVal,
      linkUrl: linkUrl
    }

    return returnValue;
  }


  $('.liveTextWrap').live('click',function(ev){
    thisControls  =  $(this).prev('.wltControls');
    var parentOfSelected = getSelectedTextHTML();
    liveEditorGlobal.lastEditedEl = parentOfSelected;
    $('.elLtWrapped').removeAttr('data-mce-style');
    $('.liveTextActive').removeClass('liveTextActive');
    $(this).addClass('liveTextActive');
    
    var currentClickedTextELPos = $(ev.target).position();
    $('.wltControls').css('top', currentClickedTextELPos.top - 60 );

    if ( thisControls.children('.wltInnerControls').length > 0 ) {
    }else{
      $('.wltControls').html('');
      $('.wltControls').removeClass('liveEditorActive');
      $(this).prev('.wltControls').append("<div class='wltInnerControls '> "+
        "<label for='wltBold' class='wltControlLabels '> <b>B</b> </label>"+
        "<input type='checkbox' id='wltBold' class='wltBold wlt_checkbox wlt-btn'  >"+
        "<label for='wltItalic' class='wltControlLabels '> <i>I</i> </label>"+
        "<input type='checkbox' id='wltItalic' class='wltItalic wlt_checkbox wlt-btn' >"+
        "<label for='wltUnderlined' class='wltControlLabels '> <span style='text-decoration: underline;'>U</span> </label>"+
        "<input type='checkbox' id='wltUnderlined' class='wltUnderlined wlt_checkbox wlt-btn'  >"+
        "<label for='wltStrike' class='wltControlLabels '> <span style='text-decoration: line-through;'>U</span> </label>"+
        "<input type='checkbox' id='wltStrike' class='wltStrike wlt_checkbox wlt-btn'  >"+
        "<label for='wltAlignLeft' class='wltControlLabels '> <span class='dashicons dashicons-editor-alignleft'></span> </label>"+
        "<input type='checkbox' id='wltAlignLeft' class='wltAlignLeft wlt_checkbox wlt-btn'  >"+
        "<label for='wltAlignCenter' class='wltControlLabels '> <span class='dashicons dashicons-editor-aligncenter'></span> </label>"+
        "<input type='checkbox' id='wltAlignCenter' class='wltAlignCenter wlt_checkbox wlt-btn'  >"+
        "<label for='wltAlignRight' class='wltControlLabels '> <span class='dashicons dashicons-editor-alignright'></span> </label>"+
        "<input type='checkbox' id='wltAlignRight' class='wltAlignRight wlt_checkbox wlt-btn'  >"+
        "<div class='wltDropdown'>"+
          "<div class='wltDTitle'><i class='fa fa-angle-double-down'></i></div>"+
          "<div class='wltDContent'> "+
            "<div class='wltDFields'> "+
              "<div class='wltdropContent-divide'> "+
                "<input class='wltFontFamily wltCInput' id='wltFontFamily'>"+
              "</div>"+
              "<div class='wltdropContent-divide'> "+
                "<label for='wltFontTag'> Typography </label>"+
                "<select class='wltCInput wltcSelect wltFontTag' id='wltFontTag' >"+
                  "<option value='p'>Paragraph</option>"+
                  "<option value='span'>Span (Inline)</option>"+
                  "<option value='a'>Link</option>"+
                  "<option value='h1' style='font-size:2.5em;'>H1 (XX Large)</option>"+
                  "<option value='h2' style='font-size:2em;'>H2 (X Large)</option>"+
                  "<option value='h3' style='font-size:1.7em;'>H3 (Large)</option>"+
                  "<option value='h4' style='font-size:1.5em;'>H4 (Medium)</option>"+
                  "<option value='h5' style='font-size:1.2em;'>H5 (Small)</option>"+
                  "<option value='h6' style='font-size:1em;'>H6 (V Small)</option>"+
                "</select> <br>"+
                "<div class='wltFontLinkContainer' style='display:none;'>"+
                  "<label for='wltFontLink'> Link URL </label>"+
                  "<input id='wltFontLink' class='wltFontLink wltCInput wltcSelect'>"+
                "</div>"+
                "<div class='wltdropContent-divide'>"+
                  "<label for='wltcFsize'> Size </label>"+
                  "<input type='number' class='wltcFsize wltCInput wltCIsmall' id='wltcFsize'> <br>"+
                  "<label for='wltcFcolor'> Color </label>"+
                  "<input type='text' class='color-picker_btn_two wltcFcolor' id='wltcFcolor'>"+
                "</div>"+
                "<div class='wltdropContent-divide'>"+
                  "<label for='wltcFlineHeight'> Line Height </label>"+
                  "<input type='number' class='wltcFlineHeight wltCInput wltCIsmall' id='wltcFlineHeight'><br>"+
                  "<label for='wltcLspacing'> Letter Space </label>"+
                  "<input type='number' class='wltcLspacing wltCInput wltCIsmall' id='wltcLspacing'>"+
                "</div>"+
              " </div>"+
            "</div> "+
          " </div> "+
        "</div>"+
      " </div>");

      $('.wltcFcolor').spectrum({ showButtons: false, showAlpha: false, showInput: true, move: function(tinycolor){ var field_id = $(this).attr('id');  $('#'+field_id).val( tinycolor.toRgbString() );  $('#'+field_id).trigger('change'); }, });

      $('.wltFontFamily').fontselect();

      $(this).prev('.wltControls').addClass('liveEditorActive');
      $('.wlt_checkbox').checkboxradio({
          icon: false
      });

      $('.widgetHandle').css('display','none');
      $('.editColBtnTop').css('display','none'); 

      $(' .wltControls ').mouseover(function(){
        $('.widgetHandle').css('display','none');
        $('.editColBtnTop').css('display','none');
      });

      $('body').on('click', function(evta){

        if ($(evta.target).parents('.liveTextActive').length > 0 || $(evta.target).parents('.wltControls').length > 0){
        }else{
          liveEditorGlobal.lastEditedEl = '';
          $('.wltControls').html('');
          $('.liveEditorActive').siblings('.inlineEditingSaveTrigger ').trigger('click');
          $('.wltControls').removeClass('liveEditorActive');
          $('.liveTextActive').removeClass('liveTextActive');

        }
        
      });

    }

    var thisSelectedStyles = getStylesSelectedEl();
    if (thisSelectedStyles['fontweight'] == '700' && $('.wltBold').is(':checked') != true ) { 
      $('.wltBold').prev('label').addClass('ui-checkboxradio-checked ui-state-active');
      $('.wltBold').prop('checked', true); 
    }else if (thisSelectedStyles['fontweight'] != '700' && $('.wltBold').is(':checked') == true ) {
      $('.wltBold').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltBold').prop('checked', false);
    }

    if (thisSelectedStyles['fontstyle'] == 'italic' && $('.wltItalic').is(':checked') != true ) { 
      $('.wltItalic').prev('label').addClass('ui-checkboxradio-checked ui-state-active');
      $('.wltItalic').prop('checked', true); 
    }else if (thisSelectedStyles['fontstyle'] != 'italic' && $('.wltItalic').is(':checked') == true ) {
      $('.wltItalic').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltItalic').prop('checked', false);
    }

    textdecorationvalue = thisSelectedStyles['textdecoration'].indexOf('underline', 0);
    textstrikevalue = thisSelectedStyles['textdecoration'].indexOf('line-through', 0);

    if (textdecorationvalue != -1 && $('.wltUnderlined').is(':checked') != true ) { 
      $('.wltUnderlined').prev('label').addClass('ui-checkboxradio-checked ui-state-active');
      $('.wltUnderlined').prop('checked', true); 
    }else if (textdecorationvalue == -1 && $('.wltUnderlined').is(':checked') == true ) {
      $('.wltUnderlined').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltUnderlined').prop('checked', false);
    }


    if (textstrikevalue != -1 && $('.wltStrike').is(':checked') != true ) { 
      $('.wltStrike').prev('label').addClass('ui-checkboxradio-checked ui-state-active');
      $('.wltStrike').prop('checked', true); 
    }else if (textstrikevalue == -1 && $('.wltStrike').is(':checked') == true ) {
      $('.wltStrike').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltStrike').prop('checked', false);
    }

    
    if (thisSelectedStyles['alignment'] != '' && typeof(thisSelectedStyles['alignment']) != 'undefined') {
      $('.wltAlignLeft').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltAlignLeft').prop('checked', false);
      $('.wltAlignCenter').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltAlignCenter').prop('checked', false);
      $('.wltAlignRight').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltAlignRight').prop('checked', false);

      if (thisSelectedStyles['alignment'] == 'left') {
        $('.wltAlignLeft').prev('label').addClass('ui-checkboxradio-checked ui-state-active');
        $('.wltAlignLeft').prop('checked', true);     
      }
      if (thisSelectedStyles['alignment'] == 'center') {
        $('.wltAlignCenter').prev('label').addClass('ui-checkboxradio-checked ui-state-active');
        $('.wltAlignCenter').prop('checked', true);     
      }
      if (thisSelectedStyles['alignment'] == 'right') {
        $('.wltAlignRight').prev('label').addClass('ui-checkboxradio-checked ui-state-active');
        $('.wltAlignRight').prop('checked', true);     
      }
      
    }
    if (thisSelectedStyles['tagName'] != '' && typeof(thisSelectedStyles['tagName']) != 'undefined') {
      $('.wltFontTag').val( thisSelectedStyles['tagName'].toLowerCase() );
      if (thisSelectedStyles['tagName'] == 'a' || thisSelectedStyles['tagName'] == 'A') {
        $('.wltFontLinkContainer').css('display','block');
        if (thisSelectedStyles['linkUrl'] != '' && typeof(thisSelectedStyles['linkUrl']) != 'undefined') {
          $('.wltFontLink').val( thisSelectedStyles['linkUrl'] );
        }
      }else{
        $('.wltFontLinkContainer').css('display','none');
        $('.wltFontLink').val( '' );
      }
    }

    if (thisSelectedStyles['fontSize'] != '' && typeof(thisSelectedStyles['fontSize']) != 'undefined') {
      $('.wltcFsize').val( thisSelectedStyles['fontSize'].replace("px", "") );
    }

    if (thisSelectedStyles['lineHeight'] != '' && typeof(thisSelectedStyles['lineHeight']) != 'undefined') {
      pxLineHeight = parseInt(thisSelectedStyles['lineHeight'] ,10);
      $('.wltcFlineHeight').val( pxLineHeight );
    }
    if (thisSelectedStyles['letterSpacing'] != '' && typeof(thisSelectedStyles['letterSpacing']) != 'undefined') {
      pxletterSpace = parseInt(thisSelectedStyles['letterSpacing'] ,10);
      $('.wltcLspacing').val( pxletterSpace );
    }
    if (thisSelectedStyles['fontColor'] != '' && typeof(thisSelectedStyles['fontColor']) != 'undefined') {
      $('.wltcFcolor').val( thisSelectedStyles['fontColor'] );
      $('.wltcFcolor').spectrum( 'set', $('.wltcFcolor').val() );
    }
    if (thisSelectedStyles['fontFamily'] != '' && typeof(thisSelectedStyles['fontFamily']) != 'undefined') {
      $('.wltFontFamily').val( thisSelectedStyles['fontFamily'] );
      var fontvalue = thisSelectedStyles['fontFamily'].replace(/\+/g, ' ');
      $('.'+'wltFontFamily').siblings('.font-select').children('a').children('.font_select_placeholder').css('font-family','Arial');
      fontvalue = fontvalue.replace(/"/g, '');
      $('.'+'wltFontFamily').siblings('.font-select').children('a').children('.font_select_placeholder').html(fontvalue);

      $('.wltFontFamily').next('.font-select').find('.fs-drop').css('display','block');

      /*
      var thisFsResults = $('.wltFontFamily').next('.font-select').find('.fs-results');
      $(thisFsResults).animate({
        scrollTop: 0
      }, 0);
      $(thisFsResults).find('li:contains("'+fontvalue+'")').addClass('active');
      var scrollToEl = $(thisFsResults).find('li:contains("'+fontvalue+'")');
      if ($(scrollToEl).length > 0 ) {
        var childPos = scrollToEl.offset();
        var parentPos = thisFsResults.parent().offset();
        var childOffset = {
            top: childPos.top - parentPos.top,
            left: childPos.left - parentPos.left
        }
        $(thisFsResults).animate({
          scrollTop: childOffset.top-40
        });
      }
      */
        
    }
  });



  $('.wlt-btn').live('click',function(ev){

    if ($(this).hasClass('wltBold')) {  applyStylesOnSelectedEl('bold', $('.wltBold').is(':checked'), liveEditorGlobal.lastEditedEl );  }
    
    if ($(this).hasClass('wltItalic')) { applyStylesOnSelectedEl('italic', $('.wltItalic').is(':checked'), liveEditorGlobal.lastEditedEl ); }

    if ($(this).hasClass('wltUnderlined')) { applyStylesOnSelectedEl('underlined', $('.wltUnderlined').is(':checked'), liveEditorGlobal.lastEditedEl ); }

    if ($(this).hasClass('wltStrike')) { applyStylesOnSelectedEl('strike', $('.wltStrike').is(':checked'), liveEditorGlobal.lastEditedEl ); }

    if ($(this).hasClass('wltAlignLeft')) { 
      applyStylesOnSelectedEl('alignLeft', $('.wltAlignLeft').is(':checked'), liveEditorGlobal.lastEditedEl );
      $('.wltAlignCenter').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltAlignCenter').prop('checked', false);
      $('.wltAlignRight').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltAlignRight').prop('checked', false);
    }

    if ($(this).hasClass('wltAlignCenter')) { 
      applyStylesOnSelectedEl('alignCenter', $('.wltAlignCenter').is(':checked'), liveEditorGlobal.lastEditedEl ); 
      $('.wltAlignLeft').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltAlignLeft').prop('checked', false);
      $('.wltAlignRight').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltAlignRight').prop('checked', false);
    }

    if ($(this).hasClass('wltAlignRight')) { 
      applyStylesOnSelectedEl('alignRight', $('.wltAlignRight').is(':checked'), liveEditorGlobal.lastEditedEl ); 
      $('.wltAlignLeft').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltAlignLeft').prop('checked', false);
      $('.wltAlignCenter').prev('label').removeClass('ui-checkboxradio-checked ui-state-active');
      $('.wltAlignCenter').prop('checked', false);
    }
  });

  $('.wltCInput').live('change',function(ev){
    if ($(this).hasClass('wltFontTag')) {  applyStylesOnSelectedEl('fontTag', $('.wltFontTag').val() , liveEditorGlobal.lastEditedEl );  }
    if ($(this).hasClass('wltcFsize')) {  applyStylesOnSelectedEl('fontSize', $('.wltcFsize').val(), liveEditorGlobal.lastEditedEl );  }
    if ($(this).hasClass('wltcFlineHeight')) {  applyStylesOnSelectedEl('fontLineHeight', $('.wltcFlineHeight').val(), liveEditorGlobal.lastEditedEl );  }
    if ($(this).hasClass('wltcLspacing')) {  applyStylesOnSelectedEl('fontLSpace', $('.wltcLspacing').val(), liveEditorGlobal.lastEditedEl );  }
    if ($(this).hasClass('wltFontFamily')) {  applyStylesOnSelectedEl('fontFamily', $('.wltFontFamily').val(), liveEditorGlobal.lastEditedEl );  }

    if ($(this).hasClass('wltFontLink')) {  applyStylesOnSelectedEl('linkUrl', $('.wltFontLink').val(), liveEditorGlobal.lastEditedEl );  }
  });


  $('.wltcFcolor').live('change',function(ev){
    if ($(this).hasClass('wltcFcolor')) {  applyStylesOnSelectedEl('fontColor', $('.wltcFcolor').val(), liveEditorGlobal.lastEditedEl );  }
  });


  $('.wltDTitle').live('click',function(){
    if (  $('.wltDTitle').hasClass('dropdownActive') ) {
      $('.wltDContent').css('display','none');
      $('.wltDTitle').removeClass('dropdownActive');
    }else{
      $('.wltDContent').css('display','block');
      $('.wltDTitle').addClass('dropdownActive');

      var fontvalue = $('.'+'wltFontFamily').siblings('.font-select').children('a').children('.font_select_placeholder').html();
      var thisFsResults = $('.wltFontFamily').next('.font-select').find('.fs-results');
      $(thisFsResults).animate({
        scrollTop: 0
      }, 0);
      $(thisFsResults).find('li:contains("'+fontvalue+'")').addClass('active');
      var scrollToEl = $(thisFsResults).find('li:contains("'+fontvalue+'")');
      if ($(scrollToEl).length > 0 ) {
        var childPos = scrollToEl.offset();
        var parentPos = thisFsResults.parent().offset();
        var childOffset = {
            top: childPos.top - parentPos.top,
            left: childPos.left - parentPos.left
        }
        $(thisFsResults).animate({
          scrollTop: childOffset.top-40
        });
      }

    }
    
  });



  $('.widgetTextTag').on('change',function(){
    if ( $(this).val() == 'a' ) {
      $('.linkOpsDiv').css('display','block');
    }else{
      $('.linkOpsDiv').css('display','none');
    }
  });

/* ----------- Live Text Editor Ends Here -------------- */




$('.rowVideoType').on('change',function(){
  var rowVideoType = $(this).val();
  if (rowVideoType == 'mp4') {
    $('.bgrowmp4').css("display",'block');
    $('.bgrowyt').css("display",'none');
  }
  if (rowVideoType == 'yt') {
    $('.bgrowyt').css("display",'block');
    $('.bgrowmp4').css("display",'none');
  }
  
});

$('.linkedField').on('change', function(ev){
  changedField = $(ev.target);
  var changeUpdatedAttr = $(changedField).attr('data-changeupdated');
  if (typeof(changeUpdatedAttr) == 'undefined') {
    changeUpdatedAttr = 'false';
  }
  if (changeUpdatedAttr == 'true') {
  }else{
    linkedBtn = changedField.siblings('.linkfieldBtn');
    if ( linkedBtn.hasClass('linkedBtn') ) {
      changedFieldVal = $(changedField).val();
      changedField.siblings('.linkedField').val(changedFieldVal);

      var siblings = changedField.siblings();
      $.each(siblings,function(i,v){
        $(v).val(changedFieldVal);
        $(v).attr('data-changeupdated','true');
        $(v).trigger('change');
      });
    }
  }
   
  $(changedField).attr('data-changeupdated','false'); 
});

$('.card').click(function(ev){
  if ( $(ev.target).hasClass('updateTemplate') ) {

  }else{
    
    $('.card').css('background-color','#f0f0f0');
    $(this).children('input').prop("checked",true);

    
    $('.card').children('.ui-effects-placeholder').remove();
    $('.card').css('background-color','#f0f0f0');
    $(this).css('background-color','#89d8fb');

    $('.card').children('.updateTemplate').remove();
    $(this).append('<div id="updateTemplate" class="btn-green  updateTemplate" style=" padding:5px 30px; font-size:16px;"> Next </div>');
    $('.updateTemplate').effect( "shake",{
      distance:10,
      times:2
    });

    if ( $(this).hasClass('tempPack1') || $(this).hasClass('tempPaca') ) {
    }else{

    }

  }
    
  
  
});


$('.openPageOpsBtn').click(function(){
  $('.pageops_modal').show(300);
});

$('.closePageOpsBtn').click(function(){

  var pageBgImage = $('.pageBgImage').val();
  var pageBgColor = $('.pageBgColor').val();
  var pagePaddingTop = $('.pagePaddingTop').val();
  var pagePaddingBottom = $('.pagePaddingBottom').val();
  var pagePaddingLeft = $('.pagePaddingLeft').val();
  var pagePaddingRight = $('.pagePaddingRight').val(); 

  $('#pbWrapper').attr('style','background-image: url("'+pageBgImage+'"); background-size:cover; background-color:'+pageBgColor+'; padding: '+pagePaddingTop+'% '+pagePaddingRight+'% '+pagePaddingBottom+'% '+pagePaddingLeft+'%; display:block;  ');

  $('.pageops_modal').hide(300);
});

$('.pageOpsField').on('change',function(){
  
  var pageBgImage = $('.pageBgImage').val();
  var pageBgColor = $('.pageBgColor').val();
  var pagePaddingTop = $('.pagePaddingTop').val();
  var pagePaddingBottom = $('.pagePaddingBottom').val();
  var pagePaddingLeft = $('.pagePaddingLeft').val();
  var pagePaddingRight = $('.pagePaddingRight').val(); 
  var POPBDefaultsEnable = $('.POPBDefaultsEnable').val(); 
  if ($('.pb_fullScreenEditorButton').hasClass('EditorActive') ) {
    displayEditor = 'display:block;';
  }else{
    displayEditor = 'display:none;';
  }

  var selectedOptinType = pageBuilderApp.PageBuilderModel.get('optinType');
  pbWrapperHeight = '';
  if (selectedOptinType == 'Full Page') {
    pbWrapperHeight = 'height:95vh;';
  }

  $('#pbWrapper').css({
      'padding-top': pagePaddingTop+'%',
      'padding-bottom': pagePaddingBottom+'%',
      'padding-left': pagePaddingLeft+'%',
      'padding-right': pagePaddingRight+'%',
      'background-image' : 'url("'+pageBgImage+'")',
      'background-size': 'cover',
      'background-color' : pageBgColor,
      'display':'block',
      'height':pbWrapperHeight,
  });

  var currentVPSPageOps = $('.currentViewPortSize').val();
    if (currentVPSPageOps == 'rbt-l') {
      $('#pbWrapper').css({
        'padding-top': $('.pagePaddingTop').val()+'%',
        'padding-bottom':$('.pagePaddingBottom').val()+'%',
        'padding-left':$('.pagePaddingLeft').val()+'%',
        'padding-right':$('.pagePaddingRight').val()+'%',
      });
    }

    if (currentVPSPageOps == 'rbt-m') {
      $('#pbWrapper').css({
        'padding-top': $('.pagePaddingTopTablet').val()+'%',
        'padding-bottom':$('.pagePaddingBottomTablet').val()+'%',
        'padding-left':$('.pagePaddingLeftTablet').val()+'%',
        'padding-right':$('.pagePaddingRightTablet').val()+'%',
      });
    }

    if (currentVPSPageOps == 'rbt-s') {
      $('#pbWrapper').css({
        'padding-top': $('.pagePaddingTopMobile').val()+'%',
        'padding-bottom':$('.pagePaddingBottomMobile').val()+'%',
        'padding-left':$('.pagePaddingLeftMobile').val()+'%',
        'padding-right':$('.pagePaddingRightMobile').val()+'%',
      });
    }



  if (POPBDefaultsEnable == 'true') {

    var POPB_typefaces =  {
      typefaceHOne:$('.typefaceHOne').val(),
      typefaceHTwo:$('.typefaceHTwo').val(),
      typefaceH3:$('.typefaceH3').val(),
      typefaceH4:$('.typefaceH4').val(),
      typefaceH5:$('.typefaceH5').val(),
      typefaceH6:$('.typefaceH6').val(),
      typefaceParagraph:$('.typefaceParagraph').val(),
      typefaceButton:$('.typefaceButton').val(),
      typefaceAnchorLink:$('.typefaceAnchorLink').val()
    };

    var POPB_typeSizes = {
      typeSizeHOne:$('.typeSizeHOne').val(),
      typeSizeHTwo:$('.typeSizeHTwo').val(),
      typeSizeH3:$('.typeSizeH3').val(),
      typeSizeH4:$('.typeSizeH4').val(),
      typeSizeH5:$('.typeSizeH5').val(),
      typeSizeH6:$('.typeSizeH6').val(),
      typeSizeParagraph:$('.typeSizeParagraph').val(),
      typeSizeButton:$('.typeSizeButton').val(),
      typeSizeAnchorLink:$('.typeSizeAnchorLink').val(),
    };

    $('#fontLoaderContainer').html('<link rel="stylesheet"href="https://fonts.googleapis.com/css?family='+POPB_typefaces['typefaceHOne']+'|'+POPB_typefaces['typefaceHTwo']+'|'+POPB_typefaces['typefaceParagraph']+'|'+POPB_typefaces['typefaceButton']+'|'+POPB_typefaces['typefaceAnchorLink']+' ">');

          var POPBGlobalStylesTag = '\n'+

            '#pbWrapper h1 { font-family:'+POPB_typefaces['typefaceHOne'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeHOne']+'px ; }  \n'+

            '#pbWrapper h2 { font-family:'+POPB_typefaces['typefaceHTwo'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeHTwo']+'px ; }  \n'+

            '#pbWrapper h3 { font-family:'+POPB_typefaces['typefaceH3'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeH3']+'px ; }  \n'+

            '#pbWrapper h4 { font-family:'+POPB_typefaces['typefaceH4'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeH4']+'px ; }  \n'+

            '#pbWrapper h5 { font-family:'+POPB_typefaces['typefaceH5'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeH5']+'px ; }  \n'+

            '#pbWrapper h6 { font-family:'+POPB_typefaces['typefaceH6'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeH6']+'px ; }  \n'+

            '#pbWrapper p { font-family:'+POPB_typefaces['typefaceParagraph'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeParagraph']+'px ; }  \n'+

            '#pbWrapper p span { font-family:'+POPB_typefaces['typefaceParagraph'].replace(/\+/g, ' ')+'; }  \n'+

            '#pbWrapper button { font-family:'+POPB_typefaces['typefaceButton'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeButton']+'px; }  \n'+
            
            '#pbWrapper a { font-family:'+POPB_typefaces['typefaceAnchorLink'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeAnchorLink']+'px ; } \n';


          if (currentVPSPageOps == 'rbt-m') {

            var POPBGlobalStylesTag = '\n'+

            '#pbWrapper h1 {  font-size:'+$('.typeSizeHOneTablet').val()+'px !important; }  \n'+

            '#pbWrapper h2 {  font-size:'+$('.typeSizeHTwoTablet').val()+'px !important; }  \n'+

            '#pbWrapper h3{  font-size:'+$('.typeSizeH3Tablet').val()+'px !important; }  \n'+

            '#pbWrapper h4{  font-size:'+$('.typeSizeH4Tablet').val()+'px !important; }  \n'+

            '#pbWrapper h3{  font-size:'+$('.typeSizeH3Tablet').val()+'px !important; }  \n'+

            '#pbWrapper h3{  font-size:'+$('.typeSizeH3Tablet').val()+'px !important; }  \n'+

            '#pbWrapper p {  font-size:'+$('.typeSizeParagraphTablet').val()+'px !important; }  \n'+

            '#pbWrapper p span { font-size:'+$('.typeSizeParagraphTablet').val()+'px; }  \n'+

            '#pbWrapper button { font-size:'+$('.typeSizeButtonTablet').val()+'px; }  \n'+
            
            '#pbWrapper a { font-size:'+$('.typeSizeAnchorLinkTablet').val()+'px !important; } \n';

          }
          if (currentVPSPageOps == 'rbt-s') {

            var POPBGlobalStylesTag = '\n'+

            '#pbWrapper h1 {  font-size:'+$('.typeSizeHOneMobile').val()+'px !important; }  \n'+

            '#pbWrapper h2 {  font-size:'+$('.typeSizeHTwoMobile').val()+'px !important; }  \n'+

            '#pbWrapper h3{  font-size:'+$('.typeSizeH3Mobile').val()+'px !important; }  \n'+

            '#pbWrapper h4{  font-size:'+$('.typeSizeH4Mobile').val()+'px !important; }  \n'+

            '#pbWrapper h3{  font-size:'+$('.typeSizeH3Mobile').val()+'px !important; }  \n'+

            '#pbWrapper h3{  font-size:'+$('.typeSizeH3Mobile').val()+'px !important; }  \n'+

            '#pbWrapper p {  font-size:'+$('.typeSizeParagraphMobile').val()+'px !important; }  \n'+

            '#pbWrapper p span { font-size:'+$('.typeSizeParagraphMobile').val()+'px; }  \n'+

            '#pbWrapper button { font-size:'+$('.typeSizeButtonMobile').val()+'px; }  \n'+
            
            '#pbWrapper a { font-size:'+$('.typeSizeAnchorLinkMobile').val()+'px !important; } \n';

          }
          

          $('#POPBGlobalStylesTag').html(POPBGlobalStylesTag);

  }else{
    $('#POPBGlobalStylesTag').html('');
  }


  var pageOptions = {
    bodyBackgroundType: $('.bodyBackgroundType:checked').val(),
    bodyGradient: {
      bodyGradientColorFirst: $('.bodyGradientColorFirst').val(),
      bodyGradientLocationFirst: $('.bodyGradientLocationFirst').val(),
      bodyGradientColorSecond: $('.bodyGradientColorSecond').val(),
      bodyGradientLocationSecond: $('.bodyGradientLocationSecond').val(),
      bodyGradientType: $('.bodyGradientType').val(),
      bodyGradientPosition: $('.bodyGradientPosition').val(),
      bodyGradientAngle: $('.bodyGradientAngle').val(),
    },
    bodyHoverOptions: {
      bodyBgColorHover: $('.bodyBgColorHover').val(),
      bodyBackgroundTypeHover: $('.bodyBackgroundTypeHover:checked').val(),
      bodyHoverTransitionDuration: $('.bodyHoverTransitionDuration').val(),
      bodyGradientHover: {
        bodyGradientColorFirstHover: $('.bodyGradientColorFirstHover').val(),
        bodyGradientLocationFirstHover: $('.bodyGradientLocationFirstHover').val(),
        bodyGradientColorSecondHover: $('.bodyGradientColorSecondHover').val(),
        bodyGradientLocationSecondHover: $('.bodyGradientLocationSecondHover').val(),
        bodyGradientTypeHover: $('.bodyGradientTypeHover').val(),
        bodyGradientPositionHover: $('.bodyGradientPositionHover').val(),
        bodyGradientAngleHover: $('.bodyGradientAngleHover').val(),
      }
    },
    bodyOverlayBackgroundType: $('.bodyOverlayBackgroundType:checked').val(),
    bodyOverlayGradient: {
      bodyOverlayGradientColorFirst: $('.bodyOverlayGradientColorFirst').val(),
      bodyOverlayGradientLocationFirst: $('.bodyOverlayGradientLocationFirst').val(),
      bodyOverlayGradientColorSecond: $('.bodyOverlayGradientColorSecond').val(),
      bodyOverlayGradientLocationSecond: $('.bodyOverlayGradientLocationSecond').val(),
      bodyOverlayGradientType: $('.bodyOverlayGradientType').val(),
      bodyOverlayGradientPosition: $('.bodyOverlayGradientPosition').val(),
      bodyOverlayGradientAngle: $('.bodyOverlayGradientAngle').val(),
    },
    bodyBgOverlayColor: $('.bodyBgOverlayColor').val(),
    bodyBorderType:$('.bodyBorderType').val(),
    bodyBorderWidth:$('.bodyBorderWidth').val(),
    bodyBorderColor:$('.bodyBorderColor').val(),
    bodyBorderRadius:{
      bbrt:$('.bbrt').val(),
      bbrb:$('.bbrb').val(),
      bbrl:$('.bbrl').val(),
      bbrr:$('.bbrr').val(),
    },
  };
  var bodyID = 'pbWrapper';
  var bodyBackgroundOptions = 'background-color:' + pageBgColor + ';';
  if (pageBgImage != '') {
    bodyBackgroundOptions = 'background: url(' + pageBgImage + '); background-size: cover; ';
  }
  if (typeof (pageOptions['bodyBackgroundType']) !== 'undefined') {
    if (pageOptions['bodyBackgroundType'] == 'gradient') {
      var bodyGradient = pageOptions['bodyGradient'];
      if (bodyGradient['bodyGradientType'] == 'linear') {
        bodyBackgroundOptions = 'background: linear-gradient(' + bodyGradient['bodyGradientAngle'] + 'deg, ' + bodyGradient['bodyGradientColorFirst'] + ' ' + bodyGradient['bodyGradientLocationFirst'] + '%,' + bodyGradient['bodyGradientColorSecond'] + ' ' + bodyGradient['bodyGradientLocationSecond'] + '%);';
      }
      if (bodyGradient['bodyGradientType'] == 'radial') {
        bodyBackgroundOptions = 'background: radial-gradient(at ' + bodyGradient['bodyGradientPosition'] + ', ' + bodyGradient['bodyGradientColorFirst'] + ' ' + bodyGradient['bodyGradientLocationFirst'] + '%,' + bodyGradient['bodyGradientColorSecond'] + ' ' + bodyGradient['bodyGradientLocationSecond'] + '%);';
      }
    }
  }
  var thisbodyHoverStyleTag = '';
  var thisbodyHoverOption = '';
  if (typeof (pageOptions['bodyHoverOptions']) !== 'undefined') {
    var bodyHoverOptions = pageOptions['bodyHoverOptions'];
    if (bodyHoverOptions['bodyBackgroundTypeHover'] == 'solid') {
      var thisbodyHoverOption = ' #' + bodyID + ':hover { background:' + bodyHoverOptions['bodyBgColorHover'] + ' !important; transition: all ' + bodyHoverOptions['bodyHoverTransitionDuration'] + 's; }';
    }
    if (bodyHoverOptions['bodyBackgroundTypeHover'] == 'gradient') {
      var bodyGradientHover = bodyHoverOptions['bodyGradientHover'];
      if (bodyGradientHover['bodyGradientTypeHover'] == 'linear') {
        thisbodyHoverOption = ' #' + bodyID + ':hover { background: linear-gradient(' + bodyGradientHover['bodyGradientAngleHover'] + 'deg, ' + bodyGradientHover['bodyGradientColorFirstHover'] + ' ' + bodyGradientHover['bodyGradientLocationFirstHover'] + '%,' + bodyGradientHover['bodyGradientColorSecondHover'] + ' ' + bodyGradientHover['bodyGradientLocationSecondHover'] + '%) !important; transition: all ' + bodyHoverOptions['bodyHoverTransitionDuration'] + 's; }';
      }
      if (bodyGradientHover['bodyGradientTypeHover'] == 'radial') {
        thisbodyHoverOption = ' #' + bodyID + ':hover { background: radial-gradient(at ' + bodyGradientHover['bodyGradientPositionHover'] + ', ' + bodyGradientHover['bodyGradientColorFirstHover'] + ' ' + bodyGradientHover['bodyGradientLocationFirstHover'] + '%,' + bodyGradientHover['bodyGradientColorSecondHover'] + ' ' + bodyGradientHover['bodyGradientLocationSecondHover'] + '%) !important; transition: all ' + bodyHoverOptions['bodyHoverTransitionDuration'] + 's; }';
      }
    }
    $('#POPBBodyHoverStylesTag').html(thisbodyHoverOption);
  }
  bodyOverlayBackgroundOptions = '';
  if (typeof (pageOptions['bodyBgOverlayColor']) !== 'undefined') {
    var bodyOverlayBackgroundOptions = 'background:' + pageOptions['bodyBgOverlayColor'] + '; background-color:' + pageOptions['bodyBgOverlayColor'] + ';';
  }
  if (typeof (pageOptions['bodyOverlayBackgroundType']) !== 'undefined') {
    if (pageOptions['bodyOverlayBackgroundType'] == 'gradient') {
      var bodyOverlayGradient = pageOptions['bodyOverlayGradient'];
      if (bodyOverlayGradient['bodyOverlayGradientType'] == 'linear') {
        bodyOverlayBackgroundOptions = 'background: linear-gradient(' + bodyOverlayGradient['bodyOverlayGradientAngle'] + 'deg, ' + bodyOverlayGradient['bodyOverlayGradientColorFirst'] + ' ' + bodyOverlayGradient['bodyOverlayGradientLocationFirst'] + '%,' + bodyOverlayGradient['bodyOverlayGradientColorSecond'] + ' ' + bodyOverlayGradient['bodyOverlayGradientLocationSecond'] + '%);';
      }
      if (bodyOverlayGradient['bodyOverlayGradientType'] == 'radial') {
        bodyOverlayBackgroundOptions = 'background: radial-gradient(at ' + bodyOverlayGradient['bodyOverlayGradientPosition'] + ', ' + bodyOverlayGradient['bodyOverlayGradientColorFirst'] + ' ' + bodyOverlayGradient['bodyOverlayGradientLocationFirst'] + '%,' + bodyOverlayGradient['bodyOverlayGradientColorSecond'] + ' ' + bodyOverlayGradient['bodyGradientLocationSecond'] + '%);';
      }
    }
  }
  $('#pbWrapperContainerOverlay').attr('style', bodyOverlayBackgroundOptions);

    if (typeof(bodyBorderRadius)  == 'undefined') { bodyBorderRadius = ''; }
    bodyBorderType = ''; bodyBorderWidth = ''; bodyBorderColor = '';
    if (typeof(pageOptions['bodyBorderType'])  != 'undefined') {
      bodyBorderType = pageOptions['bodyBorderType'];
      bodyBorderWidth = pageOptions['bodyBorderWidth'];
      bodyBorderColor = pageOptions['bodyBorderColor'];
      bodyBorderRadius = pageOptions['bodyBorderRadius'];
      if ( typeof(bodyBorderRadius['bbrt']) != 'undefined') {
      }else{
        bodyBorderRadius['bbrt'] = bodyBorderRadius;
        bodyBorderRadius['bbrb'] = bodyBorderRadius;
        bodyBorderRadius['bbrl'] = bodyBorderRadius;
        bodyBorderRadius['bbrr'] = bodyBorderRadius;
      }
    }

    $('#pbWrapper').css('border',bodyBorderWidth+'px '+bodyBorderType+' '+bodyBorderColor);
    $('#pbWrapper').css('border-top-left-radius',bodyBorderRadius['bbrt']+'px');
    $('#pbWrapper').css('border-top-right-radius',bodyBorderRadius['bbrr']+'px');
    $('#pbWrapper').css('border-bottom-right-radius',bodyBorderRadius['bbrb']+'px');
    $('#pbWrapper').css('border-bottom-left-radius',bodyBorderRadius['bbrl']+'px');

  var pbWrapperExistingStyles = $('#pbWrapper').attr('style');
  $('#pbWrapper').attr('style', pbWrapperExistingStyles+bodyBackgroundOptions);




  $('.isChagesMade').val('true');

});


$('.responsiveBtn').click(function(){

  var POPBDeafaultResponsiveStyles = 'h1{font-size:2em ; } h2{ font-size:1.5em ; } h3{ font-size:1.3em ; } h4{ font-size:1em ; } h5{ font-size:1em ; } h6{ font-size:1em ; } p, input, button, label{ font-size: 15px ; } p{  } video{ min-height: auto ; max-width: 100%; } }  .row {width:100% ; padding:30px  0 ; margin: 0 auto ;}  .column {width:99.9% ; margin-bottom: 30px ; } .column > div { padding:10px ; margin: 0 auto ; }';


  if ( $(this).hasClass('rbt-l') ) {



    // PageOps & Global Styles start
      $('#pbWrapper').css({
        'padding-top': $('.pagePaddingTop').val()+'%',
        'padding-bottom':$('.pagePaddingBottom').val()+'%',
        'padding-left':$('.pagePaddingLeft').val()+'%',
        'padding-right':$('.pagePaddingRight').val()+'%',
      });

      var POPB_typefaces =  {
        typefaceHOne:$('.typefaceHOne').val(),
        typefaceHTwo:$('.typefaceHTwo').val(),
        typefaceH3:$('.typefaceH3').val(),
        typefaceH4:$('.typefaceH4').val(),
        typefaceH5:$('.typefaceH5').val(),
        typefaceH6:$('.typefaceH6').val(),
        typefaceParagraph:$('.typefaceParagraph').val(),
        typefaceButton:$('.typefaceButton').val(),
        typefaceAnchorLink:$('.typefaceAnchorLink').val()
      };

      var POPB_typeSizes = {
        typeSizeHOne:$('.typeSizeHOne').val(),
        typeSizeHTwo:$('.typeSizeHTwo').val(),
        typeSizeH3:$('.typeSizeH3').val(),
        typeSizeH4:$('.typeSizeH4').val(),
        typeSizeH5:$('.typeSizeH5').val(),
        typeSizeH6:$('.typeSizeH6').val(),
        typeSizeParagraph:$('.typeSizeParagraph').val(),
        typeSizeButton:$('.typeSizeButton').val(),
        typeSizeAnchorLink:$('.typeSizeAnchorLink').val(),
      };

      var POPBGlobalStylesTag = '\n'+

        '#pbWrapper h1 { font-family:'+POPB_typefaces['typefaceHOne'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeHOne']+'px ; }  \n'+

        '#pbWrapper h2 { font-family:'+POPB_typefaces['typefaceHTwo'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeHTwo']+'px ; }  \n'+

        '#pbWrapper h3 { font-family:'+POPB_typefaces['typefaceH3'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeH3']+'px ; }  \n'+

        '#pbWrapper h4 { font-family:'+POPB_typefaces['typefaceH4'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeH4']+'px ; }  \n'+

        '#pbWrapper h5 { font-family:'+POPB_typefaces['typefaceH5'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeH5']+'px ; }  \n'+

        '#pbWrapper h6 { font-family:'+POPB_typefaces['typefaceH6'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeH6']+'px ; }  \n'+

        '#pbWrapper p { font-family:'+POPB_typefaces['typefaceParagraph'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeParagraph']+'px ; }  \n'+

        '#pbWrapper p span { font-family:'+POPB_typefaces['typefaceParagraph'].replace(/\+/g, ' ')+'; }  \n'+

        '#pbWrapper button { font-family:'+POPB_typefaces['typefaceButton'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeButton']+'px; }  \n'+
        
        '#pbWrapper a { font-family:'+POPB_typefaces['typefaceAnchorLink'].replace(/\+/g, ' ')+'; font-size:'+POPB_typeSizes['typeSizeAnchorLink']+'px ; } \n';

      $('#POPBDeafaultResponsiveStylesTag').html(' ');
    // PageOps & Global Styles end
  }

  if ($(this).hasClass('rbt-m')) {

    // PageOps & Global Styles start

      $('#pbWrapper').css({
        'padding-top': $('.pagePaddingTopTablet').val()+'%',
        'padding-bottom':$('.pagePaddingBottomTablet').val()+'%',
        'padding-left':$('.pagePaddingLeftTablet').val()+'%',
        'padding-right':$('.pagePaddingRightTablet').val()+'%',
      });

      var POPBGlobalStylesTag = '\n'+

        '#pbWrapper h1 {  font-size:'+$('.typeSizeHOneTablet').val()+'px !important; }  \n'+

        '#pbWrapper h2 {  font-size:'+$('.typeSizeHTwoTablet').val()+'px !important; }  \n'+

        '#pbWrapper h3{  font-size:'+$('.typeSizeH3Tablet').val()+'px !important; }  \n'+

        '#pbWrapper h4{  font-size:'+$('.typeSizeH4Tablet').val()+'px !important; }  \n'+

        '#pbWrapper h3{  font-size:'+$('.typeSizeH3Tablet').val()+'px !important; }  \n'+

        '#pbWrapper h3{  font-size:'+$('.typeSizeH3Tablet').val()+'px !important; }  \n'+

        '#pbWrapper p {  font-size:'+$('.typeSizeParagraphTablet').val()+'px !important; }  \n'+

        '#pbWrapper p span { font-size:'+$('.typeSizeParagraphTablet').val()+'px; }  \n'+

        '#pbWrapper button { font-size:'+$('.typeSizeButtonTablet').val()+'px; }  \n'+
        
        '#pbWrapper a { font-size:'+$('.typeSizeAnchorLinkTablet').val()+'px !important; } \n';

      $('#POPBDeafaultResponsiveStylesTag').html(POPBDeafaultResponsiveStyles);
    // PageOps & Global Styles end
  }

  if ($(this).hasClass('rbt-s')) {

    // PageOps & Global Styles start
      $('#pbWrapper').css({
        'padding-top': $('.pagePaddingTopMobile').val()+'%',
        'padding-bottom':$('.pagePaddingBottomMobile').val()+'%',
        'padding-left':$('.pagePaddingLeftMobile').val()+'%',
        'padding-right':$('.pagePaddingRightMobile').val()+'%',
      });

      var POPBGlobalStylesTag = '\n'+

        '#pbWrapper h1 {  font-size:'+$('.typeSizeHOneMobile').val()+'px !important; }  \n'+

        '#pbWrapper h2 {  font-size:'+$('.typeSizeHTwoMobile').val()+'px !important; }  \n'+

        '#pbWrapper h3{  font-size:'+$('.typeSizeH3Mobile').val()+'px !important; }  \n'+

        '#pbWrapper h4{  font-size:'+$('.typeSizeH4Mobile').val()+'px !important; }  \n'+

        '#pbWrapper h3{  font-size:'+$('.typeSizeH3Mobile').val()+'px !important; }  \n'+

        '#pbWrapper h3{  font-size:'+$('.typeSizeH3Mobile').val()+'px !important; }  \n'+

        '#pbWrapper p {  font-size:'+$('.typeSizeParagraphMobile').val()+'px !important; }  \n'+

        '#pbWrapper p span { font-size:'+$('.typeSizeParagraphMobile').val()+'px; }  \n'+

        '#pbWrapper button { font-size:'+$('.typeSizeButtonMobile').val()+'px; }  \n'+
        
        '#pbWrapper a { font-size:'+$('.typeSizeAnchorLinkMobile').val()+'px !important; } \n';

        $('#POPBDeafaultResponsiveStylesTag').html(POPBDeafaultResponsiveStyles);
    // PageOps & Global Styles end
  
  }

  $('#POPBGlobalStylesTag').html(POPBGlobalStylesTag);
    
});


$('#PBPO_customCSS').on('change',function(e){

  $('#PBPO_customCSS').text(POcustomCSS);
});


$('.checkIfWidgetsAreLoadedInColumn').val('false');


$('.pageBgImage').change(function(){
    var pageBgImage = $('.pageBgImage').val();
    $('#container').attr('style','background-image: url("'+pageBgImage+'"); background-size:cover;');
});

$('.card-img').mouseover(function(ev) {
  var tempprevbtn = $(ev.target).attr('class').split(' ')[1];
  $('#'+tempprevbtn).width($(ev.target).width());
  $('#'+tempprevbtn).height($(ev.target).height());
  var tempPhieght = $(ev.target).height();
  $('.tempPrev p').css('margin-top',tempPhieght/2);
  $('#'+tempprevbtn).slideDown(100);
});
$('.card').mouseleave(function(ev){
  $('.tempPrev').slideUp('100');
});

$('.tempPrev').click(function(ev) {
  var ths_tempprev = $(ev.target).attr('id');
  if (typeof(ths_tempprev) == 'undefined') { var ths_tempprev = $(ev.target).parent().attr('id'); }
  $('.pb_preview_container').attr('style','display:block;overflow:auto;');
  $('.pb_temp_prev').append('<img src='+$('img.'+ths_tempprev).attr('data-img_src')+' class="pb_temp_prev_img" >');
});

$('.pb_preview_container').click(function(){
  $('.pb_preview_container').attr('style','display:none;');
  $('.pb_temp_prev').html(' ');
});




//Responsive Options Buttons Global Script
$('.pb_editor_tab_content #tab1').css('margin','0 auto');

$('.responsiveBtn').on('click',function(){
  $('.responsiveBtn').css('background','#a5a5a5');
  


  $('.responsiveOps').css('display','none');

  if ($(this).hasClass('rbt-l') ) {
    $('.rbt-l').css('background','#2196F3');
    $('.pb_editor_tab_content #tab1').animate({margin:'0 auto', width:'100%' },500 );
    $('.responsiveOptionsContainterLarge').css('display','block');

    $('.currentViewPortSize').val('rbt-l');
    $('.pb_fullScreenEditorButtonClose').css('display','block');
     $('.newRowBtnContainerVisible').css('display','block');
    $('.pb_editor_tab_content').css('background','#fff');
  }

  if ($(this).hasClass('rbt-m') ) {
    $('.rbt-m').css('background','#2196F3');
    $('.pb_editor_tab_content #tab1').animate({margin:'0 auto', width:'768px' },500 );
    $('.responsiveOptionsContainterMedium').css('display','block');

    $('.currentViewPortSize').val('rbt-m');
    $('.pb_editor_tab_content').css('background','#5d5d5d');
    $('.newRowBtnContainerVisible').css('display','none');
    
  }

  if ($(this).hasClass('rbt-s') ) {
    $('.rbt-s').css('background','#2196F3');
    $('.pb_editor_tab_content #tab1').animate({margin:'0 auto', width:'395px' },500 );
    $('.responsiveOptionsContainterSmall').css('display','block');

    $('.currentViewPortSize').val('rbt-s');

    $('.pb_editor_tab_content').css('background','#5d5d5d');
    $('.newRowBtnContainerVisible').css('display','none');
  }


});




// POPB Tabs 

$('.popbNavItem').on('click',function(e){
  e.preventDefault();
  
  var clickedPOPBTab = $(this).attr('data-inptabID');
  var currentOptionType = $(this).children('input').attr("name");
  var currentOptionTypeSelected = $(this).children('input').is(':checked');

  if (currentOptionTypeSelected == true) {
    $(this).children('label').css({'background':'#f1f1f1', 'color':'#333'});
    $(this).children('input').prop("checked", false);
    $(this).siblings('.noneValueSelector').children('input').prop("checked", true);
    $(this).children('input').trigger("change");
  }else{
    $(this).siblings('.popbNavItem').children('label').css({'background':'#f1f1f1', 'color':'#333'});
    $(this).children('label').css({'background':'#a5a5a5', 'color':'#fff'});
    $(this).parent().next('.popb_input_tabContent').children('.popb_tab_content').css('display','none');
    $(this).parent().next().children('.'+clickedPOPBTab).css('display','block');
    $("."+currentOptionType).prop("checked", false);
    $(this).children('input').prop("checked", true);
    $(this).children('input').trigger("change");
  }

  e.stopPropagation();
  return;
    
});


$('.popbinputTabsWrapper').tooltip({
  tooltipClass: "inp-tab-tooltip-styling"
});




// Number Sliders start 
  $('.rowGradientType').on('change',function(){
    var rowGradientType = $(this).val();
    if (rowGradientType == 'linear') {
      $('.radialInput').css('display','none');
      $('.linearInput').css('display','block');
    }else{
      $('.radialInput').css('display','block');
      $('.linearInput').css('display','none');
    }
  });


  $('.rowGradientTypeHover').on('change',function(){
    var rowGradientType = $(this).val();
    if (rowGradientType == 'linear') {
      $('.radialInputHover').css('display','none');
      $('.linearInputHover').css('display','block');
    }else{
      $('.radialInputHover').css('display','block');
      $('.linearInputHover').css('display','none');
    }
  });

  $('.rowOverlayGradientType').on('change',function(){
    var rowOverlayGradientType = $(this).val();
    if (rowOverlayGradientType == 'linear') {
      $('.radialInput').css('display','none');
      $('.linearInput').css('display','block');
    }else{
      $('.radialInput').css('display','block');
      $('.linearInput').css('display','none');
    }
  });


  $('.colGradientType').on('change',function(){
    var colGradientType = $(this).val();
    if (colGradientType == 'linear') {
      $('.radialInputCol').css('display','none');
      $('.linearInputCol').css('display','block');
    }else{
      $('.radialInputCol').css('display','block');
      $('.linearInputCol').css('display','none');
    }
  });


  $('.widgGradientType').on('change',function(){
    var widgGradientType = $(this).val();
    if (widgGradientType == 'linear') {
      $('.radialInputWidg').css('display','none');
      $('.linearInputWidg').css('display','block');
    }else{
      $('.radialInputWidg').css('display','block');
      $('.linearInputWidg').css('display','none');
    }
  });


  $('.colGradientTypeHover').on('change',function(){
    var colGradientTypeHover = $(this).val();
    if (colGradientTypeHover == 'linear') {
      $('.radialInputColHover').css('display','none');
      $('.linearInputColHover').css('display','block');
    }else{
      $('.radialInputColHover').css('display','block');
      $('.linearInputColHover').css('display','none');
    }
  });

  $('.widgGradientTypeHover').on('change',function(){
    var widgGradientTypeHover = $(this).val();
    if (widgGradientTypeHover == 'linear') {
      $('.radialInputWidgHover').css('display','none');
      $('.linearInputWidgHover').css('display','block');
    }else{
      $('.radialInputWidgHover').css('display','block');
      $('.linearInputWidgHover').css('display','none');
    }
  });

  $( ".PoPbrangeSlider" ).slider({
    value:0,
    min: 0,
    max: 100,
    step: 5,
    slide: function( event, ui ) {
      POPBtagerInput = $(this).attr('data-targetRangeInput');
      $('.'+POPBtagerInput).val(ui.value);
      $('.'+POPBtagerInput).trigger('change');
    }
  });

  $( ".PoPbrangeSliderAngle" ).slider({
    value:0,
    min: 0,
    max: 360,
    step: 5,
    slide: function( event, ui ) {
      POPBtagerInput = $(this).attr('data-targetRangeInput');
      $('.'+POPBtagerInput).val(ui.value);
      $('.'+POPBtagerInput).trigger('change');
    }
  });

  $( ".PoPbrangeSliderTransition" ).slider({
    value:1,
    min: 0.1,
    max: 3,
    step: 0.1,
    slide: function( event, ui ) {
      POPBtagerInput = $(this).attr('data-targetRangeInput');
      $('.'+POPBtagerInput).val(ui.value);
      $('.'+POPBtagerInput).trigger('change');
    }
  });
// Number Sliders end




jQuery('#pbCountDownDate').datepicker({
  dateFormat: 'yy/mm/dd'
});




$('.popb_popup_close').click(function(){
  //console.log($(this));
  $(this).parents('.lpp_modal').slideUp('slow');
  $(this).parents('.lpp_modal').css('display','none');
});


// Save Triggers Start 

  jQuery('.row_edit_fields').change(function(){
    currentEditableRowID = jQuery('.currentEditingRow').val();

    pageBuilderApp.changedRowOpName =  $(this).attr('data-optname');


    jQuery('section[rowid="'+currentEditableRowID+'"]').children('#ulpb_row_controls').children('#editRowSave').click();
  });
  
  jQuery('.row_edit_fieldBG').change(function(){
    currentEditableRowID = jQuery('.currentEditingRow').val();

    pageBuilderApp.changedRowOpName =  $(this).attr('data-optname');

    jQuery('section[rowid="'+currentEditableRowID+'"]').children('#ulpb_row_controls').children('#editRowSave').click();
  });

  jQuery('#edit_form_close').live('click',function(ev){
        jQuery('.edit_row').slideUp();

        jQuery('#ulpb_row_controls').hide();
      });

  jQuery('#editRowSaveVisible').live('click',function(){

    currentEditableRowID = jQuery('.currentEditingRow').val();

    jQuery('section[rowid="'+currentEditableRowID+'"]').children('#ulpb_row_controls').children('#editRowSave').click();

    jQuery('.edit_row').hide(300);
    jQuery('.ulpb_row_controls').hide();
  });


  jQuery('.colOptionsFields , .popb_col_fields_container input , .popb_col_fields_container select , #columnBgColor').change(function(){
    pageBuilderApp.changedColOpName =  $(this).attr('data-optname');
    ColcurrentEditableRowID = jQuery('.ColcurrentEditableRowID').val();
    currentEditableColId = jQuery('.currentEditableColId').val();
    jQuery('section[rowid="'+ColcurrentEditableRowID+'"]').children('.ulpb_column_controls'+currentEditableColId).children('#editColumnSave').click();
  });


  jQuery('#editColumnSaveVisible').live('click',function(){

    jQuery('.edit_column').hide(300);
    jQuery('.ulpb_column_controls').hide();
  });

  function saveWidgetTriggerOffside(thisEl,changedOpType){
    //var tsua0 = performance.now();
    pageBuilderApp.changedOpType = changedOpType;
    pageBuilderApp.changedOpName =  $(thisEl).attr('data-optname');
    var that = jQuery('.closeWidgetPopup').attr('data-CurrWidget');
    
    jQuery('div[data-saveCurrWidget="'+that+'"]').click();

    ColcurrentEditableRowID = jQuery('.ColcurrentEditableRowID').val();
    currentEditableColId = jQuery('.currentEditableColId').val();
    jQuery('section[rowid="'+ColcurrentEditableRowID+'"]').children('.ulpb_column_controls'+currentEditableColId).children('#editColumnSaveWidget').click();

    //var tsua1 = performance.now();
    //console.log("Call to pbp-widgets change took " + (tsua1 - tsua0) + " milliseconds.");
  }

  $('.closeWidgetPopup').click(function(ev){
    saveWidgetTriggerOffside(this,'specific');
  });

  $('.closeWidgetPopupIcon').click(function(ev){
    saveWidgetTriggerOffside(this,'specific');
  });

  jQuery('.pbp-widgets input, .pbp-widgets select, .pbp-widgets textarea').change(function(){
    saveWidgetTriggerOffside(this,'specific');
  });

  jQuery('.widgetAnimateBtn').click(function(){
    jQuery('.isAnimateTrue').val('animate');
    jQuery('.closeWidgetPopup').click();
  });

  jQuery('.wdt-fields input , .wdt-fields select, .wdt-fields textarea , #widgetBgColor , .widgetStyling , .wdt-img input, .wdt-img select ').change(function(){
    saveWidgetTriggerOffside(this,'general');
  });


  jQuery('.wdt-img input, .wdt-img select').change(function(){ 
    saveWidgetTriggerOffside(this,'specific');
  });

  jQuery(document).on('change','.slideImgURL',function(){
    saveWidgetTriggerOffside(this,'specific');
  });

  jQuery(document).on('change','.imageSlideHeading , .imageSlideDesc , .imageSlideButtonText , .imageSlideButtonURL',function(){
    saveWidgetTriggerOffside(this,'specific');
  });

   jQuery(document).on('change','.iconListItemsContainer input , .iconListItemsContainer select ',function(){
    saveWidgetTriggerOffside(this,'specific');
  });
  
  jQuery(document).on('change','.carouselImgURL',function(){
    saveWidgetTriggerOffside(this,'specific');
  });

  jQuery(document).on('change','.formFieldItemsContainer select',function(){
    saveWidgetTriggerOffside(this,'specific');
  });
  jQuery(document).on('change','.formFieldItemsContainer input',function(){
    saveWidgetTriggerOffside(this,'specific');
  });
  jQuery(document).on('change','.formFieldItemsContainer textarea',function(){
    saveWidgetTriggerOffside(this,'specific');
  });


  jQuery('.editWidgetSaveButton').click( function(){
    jQuery('.closeWidgetPopup').click();
    jQuery('.columnWidgetPopup').hide(300);
    jQuery('.edit_column').hide(300);
    jQuery('.ulpb_column_controls').css('display','none');
    
  });

  var widgetDroppedTypeTwo = false;

  jQuery(function ($) {
      if (typeof(tinymce) !== 'undefined') {
        setTimeout(function () {
            for (var i = 0; i < tinymce.editors.length; i++) {
                tinymce.editors[i].on('change', function (ed, e) {
                    $('.closeWidgetPopup').click();
                });
            }
        }, 1000);
      }
  });

// Save Triggers End 

jQuery(document).ready(function() {

  $('.fontfamilySearchIcon').live('click',function(){
    if ($(this).parents('.font-select').find('.fontSearchField').hasClass('fontSearchHidden') ) {
      $(this).parents('.font-select').find('.fontSearchField').addClass('fontSearchVisible');
      $(this).parents('.font-select').find('.fontSearchField').removeClass('fontSearchHidden');
    }else{
      $(this).parents('.font-select').find('.fontSearchField').addClass('fontSearchHidden');
      $(this).parents('.font-select').find('.fontSearchField').removeClass('fontSearchVisible');
    }
    
  });
  $('.fontSearchField').live('change',function(){

      var fontvalue = $(this).val();
      fontvalue = convertToCamelCase(fontvalue);
      var thisFsResults = $(this).parents('.font-select').find('.fs-results');
      $(thisFsResults).scrollTop( 0 );

      var scrollToEl = $(thisFsResults).find('li:contains("'+fontvalue+'")');


      if ($(scrollToEl).length > 0 ) {
        var childPos = scrollToEl.offset();
        var parentPos = thisFsResults.parent().offset();
        var childOffset = {
            top: childPos.top - parentPos.top,
            left: childPos.left - parentPos.left
        }
        $(thisFsResults).scrollTop( childOffset.top-40 );
      }

  });
});


}( jQuery ) ); // main container end
















(function ($) {

  // Detect touch support
  $.support.touch = 'ontouchend' in document;

  // Ignore browsers without touch support
  if (!$.support.touch) {
    return;
  }

  var mouseProto = $.ui.mouse.prototype,
      _mouseInit = mouseProto._mouseInit,
      _mouseDestroy = mouseProto._mouseDestroy,
      touchHandled;

  /**
   * Simulate a mouse event based on a corresponding touch event
   * @param {Object} event A touch event
   * @param {String} simulatedType The corresponding mouse event
   */
  function simulateMouseEvent (event, simulatedType) {

    // Ignore multi-touch events
    if (event.originalEvent.touches.length > 1) {
      return;
    }

    event.preventDefault();

    var touch = event.originalEvent.changedTouches[0],
        simulatedEvent = document.createEvent('MouseEvents');
    
    // Initialize the simulated mouse event using the touch event's coordinates
    simulatedEvent.initMouseEvent(
      simulatedType,    // type
      true,             // bubbles                    
      true,             // cancelable                 
      window,           // view                       
      1,                // detail                     
      touch.screenX,    // screenX                    
      touch.screenY,    // screenY                    
      touch.clientX,    // clientX                    
      touch.clientY,    // clientY                    
      false,            // ctrlKey                    
      false,            // altKey                     
      false,            // shiftKey                   
      false,            // metaKey                    
      0,                // button                     
      null              // relatedTarget              
    );

    // Dispatch the simulated event to the target element
    event.target.dispatchEvent(simulatedEvent);
  }

  /**
   * Handle the jQuery UI widget's touchstart events
   * @param {Object} event The widget element's touchstart event
   */
  mouseProto._touchStart = function (event) {

    var self = this;

    // Ignore the event if another widget is already being handled
    if (touchHandled || !self._mouseCapture(event.originalEvent.changedTouches[0])) {
      return;
    }

    // Set the flag to prevent other widgets from inheriting the touch event
    touchHandled = true;

    // Track movement to determine if interaction was a click
    self._touchMoved = false;

    // Simulate the mouseover event
    simulateMouseEvent(event, 'mouseover');

    // Simulate the mousemove event
    simulateMouseEvent(event, 'mousemove');

    // Simulate the mousedown event
    simulateMouseEvent(event, 'mousedown');
  };

  /**
   * Handle the jQuery UI widget's touchmove events
   * @param {Object} event The document's touchmove event
   */
  mouseProto._touchMove = function (event) {

    // Ignore event if not handled
    if (!touchHandled) {
      return;
    }

    // Interaction was not a click
    this._touchMoved = true;

    // Simulate the mousemove event
    simulateMouseEvent(event, 'mousemove');
  };

  /**
   * Handle the jQuery UI widget's touchend events
   * @param {Object} event The document's touchend event
   */
  mouseProto._touchEnd = function (event) {

    // Ignore event if not handled
    if (!touchHandled) {
      return;
    }

    simulateMouseEvent(event, 'mouseup');

    simulateMouseEvent(event, 'mouseout');

    if (!this._touchMoved) {

      simulateMouseEvent(event, 'click');
    }

    touchHandled = false;
  };

  
  mouseProto._mouseInit = function () {
    
    var self = this;

    self.element.bind({
      touchstart: $.proxy(self, '_touchStart'),
      touchmove: $.proxy(self, '_touchMove'),
      touchend: $.proxy(self, '_touchEnd')
    });

    _mouseInit.call(self);
  };

  
  mouseProto._mouseDestroy = function () {
    
    var self = this;

    // Delegate the touch handlers to the widget's element
    self.element.unbind({
      touchstart: $.proxy(self, '_touchStart'),
      touchmove: $.proxy(self, '_touchMove'),
      touchend: $.proxy(self, '_touchEnd')
    });

    // Call the original $.ui.mouse destroy method
    _mouseDestroy.call(self);
  };

})(jQuery);



(function ($) {
  jQuery(document).ready(function(){
    jQuery(window).bind('beforeunload', function(){
      return 'Are you sure you want to leave there is unsaved data ?';
    });
  });



  // Templates type  filter

  $('.templatesTypeFilterItem').on('click', function(){

    $('.templatesTypeFilterItem').removeClass('active');
    $(this).addClass('active');
    var WidgetSearchQuery =  $(this).text();
    $('.template-card').hide();
        
    $('.template-card:contains("'+WidgetSearchQuery+'")').show();

    if (WidgetSearchQuery == 'All') {
      $('.template-card').show();
    }

    if (WidgetSearchQuery == 'Coming Soon') {
      $('.popup-tutorialNotice').show(300);
    }else{
      $('.popup-tutorialNotice').hide(300);
    }

  });

  $('.closeTutorialNotice').on('click', function(){
    $(this).parent().hide(300);
  });

  
})(jQuery);
  